"use strict";

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
if (!global._babelPolyfill) {
    require('babel-polyfill');
}
var commandOptions_1 = require("./commandOptions");
var jsonSchemaParser_1 = require("./jsonSchemaParser");
try {
    // optional
    require('source-map-support').install();
} catch (e) {}
var commandOptions_2 = require("./commandOptions");
exports.initialize = commandOptions_2.initialize;
function dtsgenerator(schemas) {
    return __awaiter(this, void 0, void 0, regeneratorRuntime.mark(function _callee() {
        var parser, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, schema, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, path, lschemas, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, lschema, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, url;

        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        parser = new jsonSchemaParser_1.JsonSchemaParser();
                        _context.prev = 1;

                        if (!schemas) {
                            _context.next = 22;
                            break;
                        }

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 6;

                        for (_iterator = schemas[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                            schema = _step.value;

                            parser.parseSchema(schema);
                        }
                        _context.next = 14;
                        break;

                    case 10:
                        _context.prev = 10;
                        _context.t0 = _context["catch"](6);
                        _didIteratorError = true;
                        _iteratorError = _context.t0;

                    case 14:
                        _context.prev = 14;
                        _context.prev = 15;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 17:
                        _context.prev = 17;

                        if (!_didIteratorError) {
                            _context.next = 20;
                            break;
                        }

                        throw _iteratorError;

                    case 20:
                        return _context.finish(17);

                    case 21:
                        return _context.finish(14);

                    case 22:
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        _context.prev = 25;
                        _iterator2 = commandOptions_1.default.files[Symbol.iterator]();

                    case 27:
                        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                            _context.next = 54;
                            break;
                        }

                        path = _step2.value;
                        _context.next = 31;
                        return parser.fetchLocalFileSchemas(path);

                    case 31:
                        lschemas = _context.sent;
                        _iteratorNormalCompletion4 = true;
                        _didIteratorError4 = false;
                        _iteratorError4 = undefined;
                        _context.prev = 35;

                        for (_iterator4 = lschemas[Symbol.iterator](); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                            lschema = _step4.value;

                            parser.parseSchema(lschema);
                        }
                        _context.next = 43;
                        break;

                    case 39:
                        _context.prev = 39;
                        _context.t1 = _context["catch"](35);
                        _didIteratorError4 = true;
                        _iteratorError4 = _context.t1;

                    case 43:
                        _context.prev = 43;
                        _context.prev = 44;

                        if (!_iteratorNormalCompletion4 && _iterator4.return) {
                            _iterator4.return();
                        }

                    case 46:
                        _context.prev = 46;

                        if (!_didIteratorError4) {
                            _context.next = 49;
                            break;
                        }

                        throw _iteratorError4;

                    case 49:
                        return _context.finish(46);

                    case 50:
                        return _context.finish(43);

                    case 51:
                        _iteratorNormalCompletion2 = true;
                        _context.next = 27;
                        break;

                    case 54:
                        _context.next = 60;
                        break;

                    case 56:
                        _context.prev = 56;
                        _context.t2 = _context["catch"](25);
                        _didIteratorError2 = true;
                        _iteratorError2 = _context.t2;

                    case 60:
                        _context.prev = 60;
                        _context.prev = 61;

                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }

                    case 63:
                        _context.prev = 63;

                        if (!_didIteratorError2) {
                            _context.next = 66;
                            break;
                        }

                        throw _iteratorError2;

                    case 66:
                        return _context.finish(63);

                    case 67:
                        return _context.finish(60);

                    case 68:
                        _iteratorNormalCompletion3 = true;
                        _didIteratorError3 = false;
                        _iteratorError3 = undefined;
                        _context.prev = 71;
                        _iterator3 = commandOptions_1.default.urls[Symbol.iterator]();

                    case 73:
                        if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                            _context.next = 84;
                            break;
                        }

                        url = _step3.value;
                        _context.t3 = parser;
                        _context.next = 78;
                        return parser.fetchRemoteSchema(url);

                    case 78:
                        _context.t4 = _context.sent;
                        _context.t5 = url;

                        _context.t3.parseSchema.call(_context.t3, _context.t4, _context.t5);

                    case 81:
                        _iteratorNormalCompletion3 = true;
                        _context.next = 73;
                        break;

                    case 84:
                        _context.next = 90;
                        break;

                    case 86:
                        _context.prev = 86;
                        _context.t6 = _context["catch"](71);
                        _didIteratorError3 = true;
                        _iteratorError3 = _context.t6;

                    case 90:
                        _context.prev = 90;
                        _context.prev = 91;

                        if (!_iteratorNormalCompletion3 && _iterator3.return) {
                            _iterator3.return();
                        }

                    case 93:
                        _context.prev = 93;

                        if (!_didIteratorError3) {
                            _context.next = 96;
                            break;
                        }

                        throw _iteratorError3;

                    case 96:
                        return _context.finish(93);

                    case 97:
                        return _context.finish(90);

                    case 98:
                        return _context.abrupt("return", parser.generateDts());

                    case 101:
                        _context.prev = 101;
                        _context.t7 = _context["catch"](1);
                        return _context.abrupt("return", Promise.reject(_context.t7));

                    case 104:
                    case "end":
                        return _context.stop();
                }
            }
        }, _callee, this, [[1, 101], [6, 10, 14, 22], [15,, 17, 21], [25, 56, 60, 68], [35, 39, 43, 51], [44,, 46, 50], [61,, 63, 67], [71, 86, 90, 98], [91,, 93, 97]]);
    }));
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = dtsgenerator;